// unlnk.cpp : Legt die Initialisierungsroutinen fr die DLL fest.
//
#define COMPILE_NEWAPIS_STUBS
#define WANT_GETLONGPATHNAME_WRAPPER
#include "stdafx.h"
#include "unlnk.h"
#include "newapis.h"
#include "process.h"
#include <fstream.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Beachten Sie!
//
//		Wird diese DLL dynamisch an die MFC-DLLs gebunden,
//		muss bei allen von dieser DLL exportierten Funktionen,
//		die MFC-Aufrufe durchfhren, das Makro AFX_MANAGE_STATE
//		direkt am Beginn der Funktion eingefgt sein.
//
//		Beispiel:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//		// Hier normaler Funktionsrumpf
//		}
//
//		Es ist sehr wichtig, dass dieses Makro in jeder Funktion
//		vor allen MFC-Aufrufen erscheint. Dies bedeutet, dass es
//		als erste Anweisung innerhalb der Funktion ausgefhrt werden
//		muss, sogar vor jeglichen Deklarationen von Objektvariablen,
//		da ihre Konstruktoren Aufrufe in die MFC-DLL generieren
//		knnten.
//
//		Siehe MFC Technical Notes 33 und 58 fr weitere
//		Details.
//
// * 4.1.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 1.10a'
//		Fehler bei Fsfirst/Fsnext behoben

// * 4.1.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 1.10b'
//		Suche in CLIST war falsch

// * 5.1.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 1.10c'
//		Version mit und ohne Logfile werden ber Versionsnummer unterscheidbar.

/////////////////////////////////////////////////////////////////////////////
//		Includes														
// --------------------------------------------------------------------
#include <afxtempl.h>
#include <direct.h>
// --------------------------------------------------------------------
//       Makros. & Konstanten
// --------------------------------------------------------------------

#define DLL_ABW_VERS 111
#define DLL_VERS 113
#define MAX_LW		26
#define E_OK			0		//	Kein Fehler
#define ERR_UL_NVETTER	1		//	Es existiert ein gleichnamiges File zu einem link. also z.B. win_lnk.c und win_lnk.c.lnk
#define ERR_UL_NOLNK	2		//	File ist kein Link
#define ERR_UL_NOMPC	8		//	Zielfile ist nicht auf einem aus MPC erreichbaren Laufwerk
#define ERR_UL_NOWIN	0x10	//	Quellfile ist nicht im Windowsfilesystem
#define P_EXISTS		-1		//	Pfad existiert, ein Unlink unntig

// #define DOLOG TRUE
// --------------------------------------------------------------------
//		typedefs
// --------------------------------------------------------------------
typedef struct
{
	short int	flag;
	int			dirh;
	CString		name;
}DIR;
typedef CList<DIR,DIR&> CDirList;
//DYJ 1.10a Start
typedef struct
{
//DYJ 1.11a Start
	int	dta;
/*DYJ  Ende; alt:	
	short int	pid;
*/
	short int	attr;
	CString		filename;
}FSPAR;
typedef CList<FSPAR,FSPAR&> CFSList;
//DYJ  Ende;
// --------------------------------------------------------------------
// 		lokale Funktionsprototypen
// --------------------------------------------------------------------

	static void dll_version(MPS_motregs *r);
	static void dll_versionAbwC(MPS_motregs *r);
	static void pcSymlink(MPS_motregs *r);
	static void getShortPath(MPS_motregs *r);
	static void getLongPathMPC(MPS_motregs *r);
	static void addDIR2List(MPS_motregs *r);
	static void findDIRbyHdl(MPS_motregs *r);
	static void findDIRbyName(MPS_motregs *r);
	static void getDIR(MPS_motregs *r);
	static void delDIR(MPS_motregs *r);
	static void setDIRHdl(MPS_motregs *r);
	static void unlnkMPC(MPS_motregs *r);
	static void setDrivePath(MPS_motregs *r);
	static void unLnkPath(MPS_motregs *r);
	static void logfile(MPS_motregs *r);
	static void getEnv(MPS_motregs *r);
	static void cpyWinBlk(MPS_motregs *r);
	static void replEnv(MPS_motregs *r);
	static void isOnWinFS(MPS_motregs *r);
	static void addFSP2List(MPS_motregs *r);
	static void getFSP(MPS_motregs *r);
	static void winPexec(MPS_motregs *r);
	static void setScrp(MPS_motregs *r);

	int cv_MPC2WIN(CString &ziel,CString quell);

// CUnlnkApp

BEGIN_MESSAGE_MAP(CUnlnkApp, CWinApp)
	//{{AFX_MSG_MAP(CUnlnkApp)
		// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUnlnkApp Konstruktion

CUnlnkApp::CUnlnkApp()
{
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen
	// Alle wichtigen Initialisierungen in InitInstance platzieren
}

/////////////////////////////////////////////////////////////////////////////
// Das einzige CUnlnkApp-Objekt

CUnlnkApp theApp;



// --------------------------------------------------------------------
//		Globale Variablen												
// --------------------------------------------------------------------
//	static AFX_EXTENSION_MODULE MpcsockDLL = { NULL, NULL };
	MPS_magicinfo m_info;					// global fr die DLL
	MPS_fuptr my_funclist[] = 
	{
		dll_version,
		dll_versionAbwC,
		unLnkPath,
		pcSymlink,
		getShortPath,
		getLongPathMPC,
		addDIR2List,
		findDIRbyHdl,
		findDIRbyName,
		getDIR,
		delDIR,
		setDIRHdl,
		unlnkMPC,
		setDrivePath,
		logfile,
		getEnv,
		cpyWinBlk,
		replEnv,
		isOnWinFS,
		addFSP2List,
		getFSP,
		winPexec,
		setScrp,
		NULL
	};
CDirList Dirs;
CFSList FSPars;	//DYJ 1.10a
CString DrivePath[MAX_LW];
FILE *LogF=NULL;

// --------------------------------------------------------------------
//		Funktionen														
// --------------------------------------------------------------------
/*** ------------------------------------------------------------------------ ***/
/*	void logPrintf(int level,BOOLEAN nl,const char *format1,... )				*/
/*	Gibt eine Zeile ins LOG aus. Mit Zeitangabe,...								*/
/*	Parameter:	level: Priorittslevel (0=Gering, 2=Hoch						*/
/*				nl:			zuerst ein Newline?									*/
/*				format1:	Formatstring										*/
/*				...:		andere Parameter									*/
/*	Ergebnis:	keines															*/		
/*	4.10.03 von Dimitri Junker	DYJ 0.31b										*/
/*** ------------------------------------------------------------------------ ***/
#pragma warning( disable : 4100 )
void logPrintf(const char *format,... )
{
#ifdef DOLOG
	va_list pvar;
	va_start(pvar,format);
	if(LogF)
	{
		vfprintf(LogF,format,pvar);
		fflush(LogF);
	}
	else
	{
		char str[500];
		vsprintf(str,format,pvar);
		TRACE(str);
	}
	va_end(pvar);
#endif
}
#pragma warning( default : 4100 )

// *******************************************************************************
//
// Hier die benutzerdefinierten Funktionen:
// ========================================

// Original von:
//http://www.codeguru.com/shell/gettingshortcuts.shtml
// leicht abgewandelt, u.a. auf Grund der dortigen Kommentare

CString GetShortcutTarget(const CString LinkFileName)
{
	HRESULT hres;
	
	CString Link, Temp = LinkFileName;
	logPrintf("GetShortcutTarget(%s)",LinkFileName);
	CoInitialize(NULL);
	Temp.MakeLower();
//	if (Temp.Find(".lnk")==-1)           //Check if the name ends with .lnk
		Link = LinkFileName + ".lnk";   //if not, append it
//	else
//		Link = LinkFileName;

	CString Info;
	Info.Empty();
	
	IShellLink* psl;

	//Create the ShellLink object
	hres = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,
				IID_IShellLink, (LPVOID*) &psl);
	
	if (SUCCEEDED(hres))
	{
		IPersistFile* ppf;
		//Bind the ShellLink object to the Persistent File
		hres = psl->QueryInterface( IID_IPersistFile, (LPVOID *) &ppf);
		if (SUCCEEDED(hres))
		{
			WORD wsz[MAX_PATH];
			//Get a UNICODE wide string wsz from the Link path
			MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, Link, -1, wsz,MAX_PATH);
			
			//Read the link into the persistent file
			hres = ppf->Load(wsz, 0);
			
			if (SUCCEEDED(hres))
			{
				//Read the target information from the link object
				//UNC paths are supported (SLGP_UNCPRIORITY)
				psl->GetPath(Temp.GetBuffer(1024), 1024, NULL,SLGP_UNCPRIORITY);
				Temp.ReleaseBuffer();
				Info = Temp;

				ppf->Release();
			}
		}
	}
	psl->Release();
	//Return the Target and the Argument as a CString
	if(!Info.IsEmpty())	//DYJ 1.09a
		logPrintf(" ->%s\n",Info);
	return Info;
}
	


// Creating a Link with IShellLink
// strPathObj  = Object with Path
// strPathLink = Path where the Link will appear
// strDesc = Link-Decription (the text under the Icon)
// CoInitialize(NULL) wird vorausgesetzt !!
// Original von:
// http://www.codeguru.com/shell/filelinks.shtml
// leicht abgewandelt, u.a. auf Grund der dortigen Kommentare

HRESULT CreateLink(const CString strPathObj,const CString strPathLink)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	HRESULT hres;
	IShellLink* psl;

	CString strMyPath = strPathLink;

	hres = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,IID_IShellLink, (LPVOID*) &psl);
	if (SUCCEEDED(hres))
	{
		IPersistFile* ppf;

		psl->SetPath(strPathObj);
//		psl->SetDescription(strDesc);

		hres = psl->QueryInterface( IID_IPersistFile, (LPVOID *) &ppf);

		if (SUCCEEDED(hres))
		{
			strMyPath += ".lnk";  // Important !!!

			WORD wsz[MAX_PATH];
			MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, strMyPath, -1, wsz,MAX_PATH);

			hres = ppf->Save(wsz, TRUE);
//			if (hres != S_OK )
//				MessageBox(NULL, "IPersistFile->Save() Error", "Error", MB_OK);
			
			ppf->Release();
		}
		psl->Release();
	}
	return hres;
}
// Routine 0 dll_version gibt die Versionsnummer zurck
// short int dll_version(void);

	static void dll_version(MPS_motregs *r)
	{
//DYJ 1.10c Start
#ifdef DOLOG
		r->d0=DLL_VERS+10000;
#else
		r->d0=DLL_VERS;
#endif
		/*DYJ  Ende; alt:	
		r->d0=DLL_VERS;
*/
	}
// Routine 1 dll_versionAbwC gibt die Versionsnummer zurck bis zu der diese Version abwrtskompatibel ist
// short int dll_versionAbwC(void);

	static void dll_versionAbwC(MPS_motregs *r)
	{
		r->d0=DLL_ABW_VERS;
	}


//** ------------------------------------------------------------------------ **
// Routine 3
// BOOL pcSymlink(char *oldname,char *newname);	 Erzeugt einen Link
//	Parameter:	oldname: Ziel des Links(Windowspfad)
//				newname: zu erzeugender Link (MPC-Pfad)
//	Ergebnis:	keines		
//	1.9.03 von Dimitri Junker	DYJ 1.01a
//** ------------------------------------------------------------------------ **
static void pcSymlink(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	char *oldNameWIN,*newNameMPC;
	CString newNameWin;

	oldNameWIN = (char *) (*m_info.intel_ptr)(r->a0);
	newNameMPC = (char *) (*m_info.intel_ptr)(r->a1);
	logPrintf("pcSymlink(%s,%s)\n",oldNameWIN,newNameMPC);
	if(!cv_MPC2WIN(newNameWin,newNameMPC))
		r->d0=CreateLink(oldNameWIN,newNameWin)==S_OK;
	else
		r->d0=-32;
}

//** ------------------------------------------------------------------------ **
// Routine 4
// BOOL getShortPath(char *shortName, char *longName);	 Ermittelt den kurzen Dateipfad
//	Parameter:	shortName: das Ziel
//				len: Lnge von Ziel
//				longName: der lange Dateiname
//	Ergebnis:	keines		
//	19.9.03 von Dimitri Junker	DYJ 1.02a
//** ------------------------------------------------------------------------ **
static void getShortPath(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	char *longName,*shortName;
	size_t len=r->d0;

	shortName = (char *) (*m_info.intel_ptr)(r->a0);
	longName = (char *) (*m_info.intel_ptr)(r->a1);
	r->d0=(GetShortPathName(longName,shortName,len)<=len);
}

//** ------------------------------------------------------------------------ **
// Routine 6
//	void addDIR2List(int flag,char *name)
//	Fgt eine DIR-Struktur an die Liste an
//	Parameter:	flag:	Kompatibilittsmodus
//				name:	Pfad
//	Ergebnis:	keines		
//	7.10.03 von Dimitri Junker	DYJ 1.04a
//** ------------------------------------------------------------------------ **
static void addDIR2List(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	DIR newDir;
	newDir.flag=(short int)r->d0;
	newDir.dirh=-1;
	newDir.name = (char *) (*m_info.intel_ptr)(r->a0);
//DYJ 1.09c Start
	if(newDir.name.ReverseFind('\\')!=(newDir.name.GetLength()-1))
		newDir.name+="\\";
//DYJ  Ende;
	Dirs.AddTail(newDir);
}
//** ------------------------------------------------------------------------ **
// Routine 7
//	long findDIRbyHdl(long dirh)
//	Sucht ein DIR in der Liste nach Handle
//	Parameter:	dirh:	das gesuchte hdl
//	Ergebnis:	Position des gefundenen DIR oder NULL		
//	7.10.03 von Dimitri Junker	DYJ 1.04a
//** ------------------------------------------------------------------------ **
static void findDIRbyHdl(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	if(!Dirs.IsEmpty())
	{
		POSITION pos=Dirs.GetHeadPosition();
//DYJ 1.10b Start
		int dirh=r->d0;
		DIR akt;
		r->d0=(long)pos;
		while(pos)
		{
			akt=Dirs.GetNext(pos);
			if(akt.dirh==dirh)
				break;
			r->d0=(long)pos;
		}
/*DYJ  Ende; alt:	
		int dirh=r->d1;
		DIR akt;
		while(pos)
		{
			r->d0=(long)pos;
			akt=Dirs.GetNext(pos);
			if(akt.dirh==dirh)
				break;
		}
*/
	}
	else
		r->d0=0;
}
//** ------------------------------------------------------------------------ **
// Routine 8
//	long findDIRbyName(char *name)
//	Sucht ein DIR in der Liste nach dem Pfadnamen
//	Parameter:	name:	der gesuchte Pfadname
//	Ergebnis:	Position des gefundenen DIR oder NULL		
//	7.10.03 von Dimitri Junker	DYJ 1.04a
//** ------------------------------------------------------------------------ **
static void findDIRbyName(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	if(!Dirs.IsEmpty())
	{
		POSITION pos=Dirs.GetHeadPosition();
		CString name = (char *) (*m_info.intel_ptr)(r->a0);
		DIR akt;
		logPrintf("Suche:%s\n",name);
//DYJ 1.10a Start
		r->d0=(long)pos;
		while(pos)
		{
			akt=Dirs.GetNext(pos);
			logPrintf("Name:%s\n",akt.name);
			if(!akt.name.Compare(name))
				break;
			r->d0=(long)pos;
		}
/*DYJ  Ende; alt:	
		while(pos)
		{
			r->d0=(long)pos;
			akt=Dirs.GetNext(pos);
			logPrintf("Name:%s\n",akt.name);
			if(!akt.name.Compare(name))
			{
				logPrintf("Gefunden\n");
				break;
			}
		}
*/
	}
	else
		r->d0=0;
}
//** ------------------------------------------------------------------------ **
// Routine 9
//	int getDIR(long *hdl,char *name,long pos)
//	gibt den Inhalt eines DIR zurck:
//	Parameter:	hdl:	fr die Rckgabe des Hdl, darf auch NULL sein
//				name:	fr die Rckgabe des Pfades, darf auch NULL sein
//				pos:	Position des DIR
//	Ergebnis:	Flag (Kompatibilittsmodus), den rest ber die obigen Pointer
//	7.10.03 von Dimitri Junker	DYJ 1.04a
//** ------------------------------------------------------------------------ **
static void getDIR(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	DIR akt;
	POSITION pos=(POSITION)r->d0;
	int *hdl= (int *) (*m_info.intel_ptr)(r->a0);
	unsigned char *name= (*m_info.intel_ptr)(r->a1);

	akt=Dirs.GetAt(pos);
	if(name)
		strcpy((char *) (*m_info.intel_ptr)(r->a1),akt.name);
	if(hdl)
		*hdl=(*m_info.swap_long)(akt.dirh);
	r->d0=akt.flag;
}
//** ------------------------------------------------------------------------ **
// Routine 10
//	void delDIR(long pos)
//	Lscht einen DIR aus der Liste
//	Parameter:	pos:	Position des DIR
//	Ergebnis:	keines		
//	7.10.03 von Dimitri Junker	DYJ 1.04a
//** ------------------------------------------------------------------------ **
static void delDIR(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	POSITION pos=(POSITION)r->d0;
	Dirs.RemoveAt(pos);
}
//** ------------------------------------------------------------------------ **
// Routine 11
//	void setDIRHdl(long pos,long hdl)
//	setzt bei einem DIR das Handle
//	Parameter:	pos:	Position des DIR
//				hdl:	Handle
//	Ergebnis:	keines		
//	7.10.03 von Dimitri Junker	DYJ 1.04a
//** ------------------------------------------------------------------------ **
static void setDIRHdl(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	POSITION pos=(POSITION)r->d0;
	DIR akt;
	akt=Dirs.GetAt(pos);
	akt.dirh=r->d1;
	Dirs.SetAt(pos,akt);
}
//** ------------------------------------------------------------------------ **
//	int cv_MPC2WIN(char *ziel,const char *quell)								
//	Wandelt einen Pfadnamen vom MPC-Filesystem in den von Windows				
//	Parameter:	ziel:	hierher den Windowspfad schreiben						
//				quell:	MPC-Pfad						
//	Ergebnis:	Fehler?	s. ERR_UL_SIZE etc												
//	13.9.03 von Dimitri Junker	DYJ 0.1											
//** ------------------------------------------------------------------------ **
int cv_MPC2WIN(CString &ziel,CString quell)
{	char lwk[2]="a";
	int ret=E_OK,start=2;
	logPrintf("cv_MPC2WIN:%s",quell);
	lwk[0]=quell[0];
	strupr(lwk);
//DYJ 1.08c Start
	if(*lwk=='U' && quell.GetLength()>4 && quell[4]=='\\')
/*DYJ  Ende; alt:	
	if(*lwk=='U' && quell[4]=='\\')
*/
	{
		lwk[0]=quell[3];
		strupr(lwk);
		start=4;
	}
	if(!DrivePath[*lwk-'A'].IsEmpty())
//DYJ 1.06b Start
	{
		static const unsigned char  m2w[]={
		0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,
		0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,
		0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,
		0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,
		0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,
		0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,
		0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,
		0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,
		0xc7,0xfc,0xe9,0xe2,0xe4,0xe0,0xe5,0xe7,0xea,0xeb,0xe8,0xef,0xee,0xec,0xc4,0xc2,
		0xc9,0xe6,0xc6,0xf4,0xf6,0xf2,0xfb,0xf9,0xff,0xd6,0xdc,0xa2,0xa3,0xa5,0xdf,0x9f,
		0xe1,0xed,0xf3,0xfa,0xf1,0xd1,0xa6,0xa7,0xbf,0xa9,0xaa,0xbd,0xbc,0xcd,0xab,0xbb,
		0xe3,0xf5,0xd8,0xf8,0xb4,0xb5,0xc0,0xc3,0xd5,0xa8,0x92,0xb3,0xb6,0xa9,0xae,0xbf,
		0xc0,0xc1,0xc2,0xc3,0xc4,0xc5,0xc6,0xc7,0xc8,0xc9,0xca,0xcb,0xcc,0xcd,0xce,0xcf,
		0xd0,0xd1,0xd2,0xd3,0xd4,0xd5,0xd6,0xd7,0xd8,0xd9,0xda,0xdb,0xdc,0xdd,0xde,0xdf,
		0xe0,0xe1,0xe2,0xe3,0xe4,0xe5,0xe6,0xe7,0xe8,0xe9,0xea,0xeb,0xec,0xed,0xee,0xef,
		0xf0,0xf1,0xf2,0xf3,0xf4,0xf5,0xf6,0xf7,0xf8,0xf9,0xfa,0xfb,0xfc,0xfd,0xfe,0xff};
		ziel=DrivePath[*lwk-'A'];
		while(start<quell.GetLength())
//DYJ 1.08c Start
			ziel+=m2w[(unsigned char)(quell.GetAt(start++))];
		logPrintf(" ->%s\n",ziel);
	}
	else
	{
		ret=ERR_UL_NOWIN;
		logPrintf(" ->ERR_UL_NOWIN\n");
	}
/*DYJ  Ende; alt:	
		{
			ziel+=m2w[(unsigned char)(quell.GetAt(start++))];
		}
	}
	else
		ret=ERR_UL_NOWIN;
	logPrintf(" ->%s\n",ziel);
*/
	return ret;
}
//** ------------------------------------------------------------------------ **
//	int cv_WIN2MPC(char *ziel,const char *quell)								
//	Wandelt einen Pfadnamen vom Windows-Filesystem in das von MPC				
//	Parameter:	ziel:	hierher den MPC-Pfad schreiben							
//				quell:	Windowspfad												
//	Ergebnis:	Fehler?	s. ERR_UL_SIZE etc												
//	13.9.03 von Dimitri Junker	DYJ 0.1											
//** ------------------------------------------------------------------------ **
int cv_WIN2MPC(CString &ziel,CString quell)
{
	int i, err=ERR_UL_NOMPC;
	logPrintf("cv_WIN2MPC:%s",quell);
	for(i=0;i<MAX_LW;i++)
	{
//DYJ 1.06b Start
		int len;
/*DYJ  Ende; alt:	
		size_t len;
*/
		len=DrivePath[i].GetLength();
		if(len)
		{
			if(!DrivePath[i].CompareNoCase(quell.Left(len)))
			{

//DYJ 1.06b Start
				static const unsigned char w2m[]={
				0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0a,0x0b,0x0c,0x0d,0x0e,0x0f,
				0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,0x1d,0x1e,0x1f,
				0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2a,0x2b,0x2c,0x2d,0x2e,0x2f,
				0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39,0x3a,0x3b,0x3c,0x3d,0x3e,0x3f,
				0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4a,0x4b,0x4c,0x4d,0x4e,0x4f,
				0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5a,0x5b,0x5c,0x5d,0x5e,0x5f,
				0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6a,0x6b,0x6c,0x6d,0x6e,0x6f,
				0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7a,0x7b,0x7c,0x7d,0x7e,0x7f,
				0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8a,0x8b,0x8c,0x8d,0x8e,0x8f,
				0x90,0x91,0xba,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9a,0x9b,0x9c,0x9d,0x9e,0x9f,
				0xa0,0xa1,0x9b,0x9c,0xa4,0x9d,0xa6,0xa7,0xb9,0xbd,0xaa,0xae,0xac,0xad,0xbe,0xaf,
				0xb0,0xb1,0xb2,0xbb,0xb4,0xb5,0xbc,0xb7,0xb8,0xb9,0xba,0xaf,0xac,0xab,0xbe,0xa8,
				0xb6,0xc1,0x8f,0xb7,0x8e,0xc5,0x92,0x80,0xc8,0x90,0xca,0xcb,0xcc,0xad,0xce,0xcf,
				0xd0,0xa5,0xd2,0xd3,0xd4,0xb8,0x99,0xd7,0xb2,0xd9,0xda,0xdb,0x9a,0xdd,0xde,0x9e,
				0x85,0xa0,0x83,0xb0,0x84,0x86,0x91,0x87,0x8a,0x82,0x88,0x89,0x8d,0xa1,0x8c,0x8b,
				0xf0,0xa4,0x95,0xa2,0x93,0xb1,0x94,0xf7,0xb3,0x97,0xa3,0x96,0x81,0xfd,0xfe,0x98};
				ziel="C:";
				ziel.SetAt(0,(char)(i+'A'));
				while(len<quell.GetLength())
//DYJ 1.07a Start
					ziel+=w2m[(unsigned char)(quell.GetAt(len++))];
/*DYJ  Ende; alt:	
					ziel+=w2m[quell.GetAt(len++)];
*/
/*DYJ  Ende; alt:	
				ziel="C:"+quell.Mid(len);
				ziel.SetAt(0,(char)(i+'A'));
*/
				err=E_OK;
				break;
			}
		}
	}
//DYJ 1.09a Start
	if(err)
		logPrintf(" ->err=%d\n",err);
	else
		logPrintf(" ->%s\n",ziel);
/*DYJ  Ende; alt:	
	logPrintf(" ->%s\n",ziel);
*/
	return(err);
}
///* ------------------------------------------------------------------------ **
//	int unlnk(CString &ziel,CString quell,int mode)
//	dereferenziert einen Link
//	Parameter:	ziel:	na was wohl?
//				quell:	Hmm
//				mode:	1: Name des Links zurck geben (incl. .lnk)
//	Ergebnis:	Fehler?
//	10.10.03 von Dimitri Junker	DYJ 1.04a
///* ------------------------------------------------------------------------ **
int unlnk(CString &ziel,CString quell,int mode)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	CString oFile;
	int ret=0,welle;
	CFile cf;
	CFileStatus status;
	BOOL prefLink=FALSE;

	logPrintf("unlnk(..,%s,%d)\n",quell,mode);
	welle=quell.ReverseFind('~');
	if(welle>-1) //Dann gibt es ein normales File und einen gleichnamigen Link und/oder 8.3
	{
		if(quell[welle+1]>'9')
		{
			BOOL delEnd=FALSE;
			prefLink=TRUE;
			if(quell[welle+1]=='L' || quell[welle+1]=='l')
			{
				if(quell[welle-1]=='.')
					quell.Delete(welle-1,3);
				else
					quell.Delete(welle,2);
			}
			else if(quell[welle+1]>='A' && quell[welle+1]<'K')
			{
				delEnd=TRUE;
//DYJ 1.13b Start
				quell.SetAt(welle+1,(char)(quell[welle+1]-'A'+'0'));
/*DYJ  Ende; alt:	
				quell.SetAt(welle+1,quell[welle+1]-'A'+'0');
*/
			}
			else if(quell[welle+1]>='a' && quell[welle+1]<'k') 
			{
				delEnd=TRUE;
//DYJ 1.13b Start
				quell.SetAt(welle+1,(char)(quell[welle+1]-'a'+'0'));
/*DYJ  Ende; alt:	
				quell.SetAt(welle+1,quell[welle+1]-'a'+'0');
*/
			}
			if(delEnd)
			{
				int end;
				end=quell.ReverseFind('.');
				if(end>quell.ReverseFind('\\'))
					quell=quell.Left(end);
			}
		}
	}
	if(!prefLink)
		ret=cf.GetStatus(quell,status);	//0 wenn File nicht existiert, sonst 1
	oFile=GetShortcutTarget(quell);
//DYJ 1.09a Start
	if(oFile.IsEmpty())
	{
//DYJ 1.10a Start
		ret=ERR_UL_NOLNK;
/*DYJ  Ende; alt:	
		ret+=2;
*/
		logPrintf("unlnk:err=%d\n",ret);
	}
	else if(mode==1)	//Name des Lnk-Files zurck geben
	{
		logPrintf("unlnk:mode=1:oFile=%s\n",oFile);
		quell+=".lnk";
		ziel=quell;
		logPrintf("unlnk:ziel=%s\n",ziel);
	}
	else
	{
		ziel=oFile;
		logPrintf("unlnk:ziel=%s\n",ziel);
	}
/*DYJ  Ende; alt:	
	logPrintf("unlnk:oFile=%s\n",oFile);
	if(oFile.IsEmpty())
		ret+=2;
	else if(mode==1)	//Name des Lnk-Files zurck geben
	{
		logPrintf("unlnk:mode=1:oFile=%s\n",oFile);
		quell+=".lnk";
		ziel=quell;
	}
	else
		ziel=oFile;
	logPrintf("unlnk:ziel=%s\n",ziel);
*/
	return ret;

}  
//** ------------------------------------------------------------------------ **
// Routine 12
//	int unlnkMPC(char *mzFile, const char* mqFile,int mode)
//	Dereferenziert einen Link, dazu mu zuerst der Pfad ins Windows Filesystem
//	gewandelt werden, dann eine Windowsfunktion zum eigentlichen Dereferenzieren
//	und dann das Ergebnis wieder zurck ins MagicPC Filesystem gewandelt.
//	Parameter:	mzFile:	hierher das Link-Ziel schreiben
//				mqFile:	Quellfile (ohne .lnk!)
//				mode: 	0: Ziel des Links ermitteln
//						1: Name des Linkfiles ermitteln
//						2: Wie 0 aber Windowspfad zurck geben
//	Ergebnis:	Fehler?	s. ERR_UL_NVETTER etc		
//	10.10.03 von Dimitri Junker	DYJ 1.04b
//** ------------------------------------------------------------------------ **
static void unlnkMPC(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	int err=0;
	BOOL retWin=FALSE;
	CString ziel,winPath,unlnkPath;
	char *mzFile= (char*)(*m_info.intel_ptr)(r->a0);
	char *mqFile= (char*)(*m_info.intel_ptr)(r->a1);
	short mode=(short)r->d0;
	logPrintf("unlnkMPC: %s,%d\n",mqFile,mode);
	if(mode==2)
	{
		mode=0;
		retWin=TRUE;
	}

	err=cv_MPC2WIN(winPath,mqFile);
	*mzFile='\0';	//DYJ 1.06a
	if(!err)
	{
		err=unlnk(unlnkPath,winPath,mode);
		if(err<2)
		{
			if(retWin)
				strcpy(mzFile,winPath);
			else
			{
				err|=cv_WIN2MPC(ziel,unlnkPath);
				strcpy(mzFile,ziel);
			}
		}
	}
	if(err && retWin)
	{
		err=cv_MPC2WIN(winPath,mqFile);
		strcpy(mzFile,winPath);
	}
//DYJ 1.06a Start
	logPrintf("unlnkMPC->%s err=:%d\n",mzFile,err);
/*DYJ  Ende; alt:	
	logPrintf("unlnkMPC->%s\n",mzFile);
*/
	r->d0= err;
}
//** ------------------------------------------------------------------------ **
// Routine 13
//	void setDrivePath(int mpcLw,char *winPfad)
//	Setzt die korespondierenden Pfade zu den max 26 MPC-Partitionen
//	Parameter:	mpcLw:	Partition (0=A:
//				winPfad:Entsprechender Pfad im Windowsfilesystem
//	Ergebnis:	keines		
//	7.10.03 von Dimitri Junker	DYJ 1.04a
//** ------------------------------------------------------------------------ **
static void setDrivePath(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	DrivePath[r->d0]=(char *) (*m_info.intel_ptr)(r->a0);
}

//** ------------------------------------------------------------------------ **
//	BOOL dirExist(CString dirName)
//	Prft ob ein Ordner existert
//	Parameter:	dirName:	der Ordner
//	Ergebnis:	Da?
//	7.10.03 von Dimitri Junker	DYJ 1.04a
//** ------------------------------------------------------------------------ **
BOOL dirExist(CString dirName)
{

   CFileFind finder;
//DYJ 1.10b Start
	BOOL ret;

	logPrintf("dirExist:%s\n",dirName);
	if(dirName.IsEmpty())
		ret=FALSE;
	else if(dirName.GetLength()<4)
	{
		int curdrive = _getdrive(),tstDrv;
		if(islower(dirName[0]))
			tstDrv=dirName[0]-'a'+1;
		else
			tstDrv=dirName[0]-'A'+1;
		ret= _chdrive(tstDrv)==0;
		_chdrive(curdrive);
	}
	else if(dirName.Right(1)=="\\")
	{
		dirName+=".";
		ret=finder.FindFile(dirName);
	}
	else
	{
		dirName+="\\.";
		ret=finder.FindFile(dirName);
	}
	return ret;
/*DYJ  Ende; alt:	
   if(dirName.Right(1)=="\\")
	   dirName+=".";
   else
	   dirName+="\\.";
  return finder.FindFile(dirName);
*/
}
//** ------------------------------------------------------------------------ **
// Routine 2
//	int unLnkPath(char *mzFile, char* mqFile,BOOL chkFst)
//	dereferenziert den Pfadanteil.												
//	Parameter:	mzFile:	hierher kommt der dereferenzierte Pfad					
//				mqFile:	der zu dereferenzierende Pfad							
//				chkFst:	zuerst testen, ob der Pfad so existiert?				
//	Ergebnis:	E_OK:	Pfad verfolgt und dereferenziert
//				P_EXISTS:	Pfad existierte schon ->keine Verfolgung ntig
//					nur bei chkFst mglich
//				oder Fehler														
//	10.10.03 von Dimitri Junker	DYJ 1.04a
///* ------------------------------------------------------------------------ **
static void unLnkPath(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	int err=E_OK,bsI;
	CString pfadKompl,pfadAnfang,pfadMPC,fileN;

	pfadMPC=(char *) (*m_info.intel_ptr)(r->a1);
	logPrintf("unLnkPath:%s\n",pfadMPC);



//	Ggf Filenamen entfernen
	bsI=pfadMPC.ReverseFind('\\');
	if(bsI>-1)
	{
		fileN=pfadMPC.Mid(bsI+1);
		pfadMPC=pfadMPC.Left(bsI+1);
		logPrintf("pfad:%s Filename:%s\n",pfadMPC,fileN);
		err=cv_MPC2WIN(pfadKompl,pfadMPC);

//DYJ 1.10b Start
		if(!err && pfadKompl.GetLength()<4 && !r->d0)			// Files im RootDir ignoriern
/*DYJ  Ende; alt:	
		if(!err && pfadKompl.GetLength()<3)			// Files im RootDir ignoriern
*/
			err= ERR_UL_NOLNK;
	}
	else
		err= ERR_UL_NOLNK;
	logPrintf("err:%d,chkFst:%d pfad:%s,exist:%d\n",err,r->d0,pfadKompl, dirExist(pfadKompl));
	if(!err &&(!r->d0 || !dirExist(pfadKompl)))
	{
		do
		{
			pfadAnfang=pfadKompl;
			bsI=pfadAnfang.ReverseFind('\\');
			while(bsI>-1)
			{
				CString subDirs=pfadAnfang.Mid(bsI),pfadUnlnk;
				pfadAnfang=pfadAnfang.Left(bsI);
				logPrintf("Split -> %s + %s\n",pfadAnfang,subDirs);
				bsI=pfadAnfang.ReverseFind('\\');
				if(bsI>-1 && unlnk(pfadUnlnk,pfadAnfang,0)<2)
				{
					pfadKompl=pfadUnlnk+subDirs;
					logPrintf("Neuer Pfad:%s\n",pfadKompl);
					err=cv_WIN2MPC(pfadMPC,pfadKompl);
					break;
				}
				else 
				{
					if(bsI<0)
						err=ERR_UL_NOLNK;
					pfadAnfang+=subDirs;
				}
			}
		}while(!err && !dirExist(pfadKompl));
	}
//DYJ 1.07b Start
	else if(!err)
		err=P_EXISTS;
//DYJ 1.08b Start
	if(err==ERR_UL_NOWIN && r->d0)
		err=P_EXISTS;
//DYJ  Ende;
	if(err<1)
/*DYJ  Ende; alt:	
	if(!err)
*/
	{
		pfadMPC+=fileN;
		strcpy((char *) (*m_info.intel_ptr)(r->a0),pfadMPC);
		logPrintf("unLnkPath ->%s\n",pfadMPC);
	}
	logPrintf("unLnkPath: err=%d\n",err);
	r->d0= err;
}
//** ------------------------------------------------------------------------ **
// Routine 5
// BOOL getLongPathMPC(char *longName,char *shortName);
// Ermittelt den langen Dateipfad.
//	Parameter:	longName: das Ziel
//				shortName: der kurze Pfadname
//	Ergebnis:	Fehler oder 0		
//	10.10.03 von Dimitri Junker	DYJ 1.04a										
//** ------------------------------------------------------------------------ **
static void getLongPathMPC(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	int err=0;
	CString pathShort,pathLongMPC;
	logPrintf("getLongPathMPC:%s\n",(char *) (*m_info.intel_ptr)(r->a1));

	err=cv_MPC2WIN(pathShort,(char *) (*m_info.intel_ptr)(r->a1));
	if(!err)
	{
		char pathLongWin[1000];

		GetLongPathName(pathShort,pathLongWin,sizeof(pathLongWin));
		err=cv_WIN2MPC(pathLongMPC,pathLongWin);
		if(!err)	/*DYJ 0.42a*/
			logPrintf("getLongPathMPC->%s \n",pathLongMPC);
		strcpy((char *) (*m_info.intel_ptr)(r->a0),pathLongMPC);
	}
	r->d0= err;
}
//** ------------------------------------------------------------------------ **
// Routine 14
//	BOOL logfile(char *str)
//	startet oder beendet das mitloggen bzw gibt einen String aus. Soll ein String bei
//	abgeschaltetem Log ausgegeben werden, wird dies per logPrintf gemacht.
//	Parameter:	str:	Auszugebender String oder NULL(Ein/Ausschalten)
//	Ergebnis:	Logfile aktiv?
//	19.9.03 von Dimitri Junker	DYJ 0.31b
//** ------------------------------------------------------------------------ ***/
static void logfile(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
#ifdef DOLOG
	char *str=(char *) (*m_info.intel_ptr)(r->a0);

	if(str)
	{
		if(LogF)
		{
			fprintf(LogF,str);
			fflush(LogF);
		}
		else
			logPrintf(str);
	}
	else
	{
		if(LogF)
		{
			fclose(LogF);
			LogF=NULL;
		}
		else
		{
			char *dir;
			CString pfad="";
			if((dir=getenv("LOGDIR"))==NULL)
				dir=getenv("TEMP");
			if(dir)
			{
				pfad=dir;
				if(pfad.Right(1).Compare("\\"))
					pfad+="\\";
			}
			pfad+="win_lnk.log";
			LogF=fopen(pfad,"w");
		}
	}
	r->d0=(LogF!=NULL);
#else
	r->d0=FALSE;
#endif
}

//** ------------------------------------------------------------------------ **
// Routine 15
//	long getEnv(long *ptr,char *name);
//	Ermittelt den Wert eines Environmentstrings. Da Auf MPCseite per malloc Speicher
//	reserviert werden soll wird erstmals nur ein Windows-Pointer und die Lnge zurck
//	gegeben. Spter mu dann per cpyWinBlk kopiert werden.
//	Parameter:	ptr:	Fr das Resultat, kann aber so nicht unter MPC genutzt werden!
//				name: der Name des gesuchten Environmentstrings
//	Ergebnis:	Lnge des Resultats oder 0 falls unbekannt.
//	25.10.03 von Dimitri Junker	DYJ 1.08a
//** ------------------------------------------------------------------------ ***/
static void getEnv(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	int *ptr=(int *) (*m_info.intel_ptr)(r->a0);
	char *name=(char *) (*m_info.intel_ptr)(r->a1),*winVal,*pVal=NULL;
	CString mpcVal;
	winVal=getenv(name);
	if(winVal)
	{
		if(cv_WIN2MPC(mpcVal,winVal))
			mpcVal=winVal;
		pVal=(char *)malloc(mpcVal.GetLength()+1);
	}
	if(pVal)
	{
		strcpy(pVal,mpcVal);
		*ptr=(*m_info.swap_long)((int)pVal);
		r->d0=strlen(pVal)+1;
		logPrintf("getEnv: %x =%s\n",*ptr,pVal);
	}
	else
	{
		r->d0=0;
		logPrintf("getEnv: 0\n");
	}
}
//** ------------------------------------------------------------------------ **
// Routine 16
//	void cpyWinBlk(void *ziel,long quell,size_t len,BOOL freigeben)
//	Kopiert von einem nur unter Windows erreichbaren Speicherbereich in einen 
//	unter MPC erreichbaren.
//	Parameter:	ziel:	der MPC-Speicher
//				quell:	der Windows-Speicher
//				len:	Lnge des Speicherbereiches
//				freigeben:	Windowsspeicher per free freigeben?
//	Ergebnis:	keines
//	25.10.03 von Dimitri Junker	DYJ 1.08a
//** ------------------------------------------------------------------------ ***/
static void cpyWinBlk(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	void *ziel=(void *) (*m_info.intel_ptr)(r->a0);
	void *quell=(void *) r->d0;
	logPrintf("cpyWinBlk: %x -> %x\n",quell,ziel);
	memcpy(ziel,quell,r->d1);
	if(r->d2)
		free(quell);
}
//** ------------------------------------------------------------------------ **
// Routine 17
//	long replEnv(long *newEnv,char *oldEnv);
//	Ersetzt in der Liste der z.B. bei pexec bergebenen Liste von Environmentstrings
//	Konstrukte der Art %WIN%. Da Auf MPCseite per malloc Speicher
//	reserviert werden soll wird erstmals nur ein Windows-Pointer und die Lnge zurck
//	gegeben. Spter mu dann per cpyWinBlk kopiert werden.
//	Parameter:	newEnv:	Fr das Resultat, kann aber so nicht unter MPC genutzt werden!
//				oldEnv:	Liste der Environmentstrings, getrennt duch \0, Abgeschlossen
//				durch \0\0
//	Ergebnis:	Lnge des Resultats oder 0 falls keine nderungen vorgenommen
//	25.10.03 von Dimitri Junker	DYJ 1.08a
//** ------------------------------------------------------------------------ ***/
static void replEnv(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	int *pNewEnv=(int *) (*m_info.intel_ptr)(r->a0),len=1;
//DYJ 1.13b Start
	char *oldEnv=(char *) (*m_info.intel_ptr)(r->a1);
/*DYJ  Ende; alt:	
	char *oldEnv=(char *) (*m_info.intel_ptr)(r->a1),*pVal=NULL;
*/
	CList<CString,CString&> envs;
	BOOL geaendert=FALSE;
	while(*oldEnv)
	{
		CString envStr=oldEnv;
		int idx=envStr.Find('=');
		logPrintf("ENV:%s",envStr);
		if(idx>-1 && !envStr.Mid(idx+1,5).CompareNoCase("%WIN%"))
		{
			char *winVal;
			TRACE("len:%d, idx:%d\n",envStr.GetLength(),idx);
			if(envStr.GetLength()>(idx+6) && envStr[idx+6]==':')
				winVal=getenv(envStr.Mid(idx+7));
			else
				winVal=getenv(envStr.Left(idx));
			if(winVal)
			{

//DYJ 1.13a Start
				CString mpcVal;
				logPrintf("...\n");
				envStr=envStr.Left(idx+1);
				if(cv_WIN2MPC(mpcVal,winVal))
					envStr+=winVal;
				else
					envStr+=mpcVal;
				logPrintf("ENV:%s",envStr);
/*DYJ  Ende; alt:	
				envStr=envStr.Left(idx+1);
				envStr+=winVal;
*/
				geaendert=TRUE;
			}
			logPrintf("-> %s\n",envStr);
		}
		else
			logPrintf("\n");

		len+=envStr.GetLength()+1;
		envs.AddTail(envStr);
		oldEnv=strchr(oldEnv,'\0')+1;
	}
	r->d0=0;
	if(geaendert && len>1)
	{
		char *newEnv,*ptr;
		newEnv=ptr=(char*)malloc(len);
		if(newEnv)
		{
			POSITION pos=envs.GetHeadPosition();
			while(pos)
			{
				CString &envStr=envs.GetNext(pos);
				strcpy(ptr,envStr);
				ptr+=envStr.GetLength()+1;
			}
			r->d0=len;
			*pNewEnv=(*m_info.swap_long)((int)newEnv);
		}
	}
}

//** ------------------------------------------------------------------------ **
// Routine 18
//	BOOL isOnWinFS(char* quell);
//	Gibt zurck ob sich ein File im Windowsfilesystem befindet, oder z.B. auf
//	einem Containerlaufwerk
//	Parameter:
//	Ergebnis:	keines
//	15.11.03 von Dimitri Junker	DYJ 1.09b
//** ------------------------------------------------------------------------ ***/
static void isOnWinFS(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	char lwk[2]="a";
//DYJ 1.13b Start
/*DYJ  Ende; alt:	
	int ret=0,start=2;
*/
	char *quell=(char *) (*m_info.intel_ptr)(r->a0);
	
	logPrintf("isOnWinFS:%s\n",quell);
	lwk[0]=quell[0];
	strupr(lwk);
	if(*lwk=='U' && strlen(quell)>4 && quell[4]=='\\')
	{
		lwk[0]=quell[3];
		strupr(lwk);
	}
	r->d0=!DrivePath[*lwk-'A'].IsEmpty();
}







//DYJ 1.11a Start
//** ------------------------------------------------------------------------ **
//	POSITION findFSPbyDTA(int dta)
//	Sucht ein FSPar in der Liste nach DTA-Adresse
//	Parameter:	dta:	die gesuchte DTA
//	Ergebnis:	Position des gefundenen FSPar oder NULL		
//	2.2.04 von Dimitri Junker	DYJ 1.11a
//** ------------------------------------------------------------------------ **
POSITION findFSPbyDTA(int dta)
{
	POSITION ret=0;
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	if(!FSPars.IsEmpty())
	{
		POSITION pos=FSPars.GetHeadPosition();
		ret=pos;
		while(pos)
		{
			FSPAR akt;
			akt=FSPars.GetNext(pos);
			if(akt.dta==dta)
				break;
			ret=pos;
		}
	}
	return ret;
}/*DYJ  Ende; alt:	
//** ------------------------------------------------------------------------ **
//	POSITION findFSPbyID(short int pid)
//	Sucht ein FSPar in der Liste nach ProzessID
//	Parameter:	pid:	die gesuchte ProzessID
//	Ergebnis:	Position des gefundenen FSPar oder NULL		
//	3.1.04 von Dimitri Junker	DYJ 1.10a
//** ------------------------------------------------------------------------ **
POSITION findFSPbyID(short int pid)
{
	POSITION ret=0;
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	if(!FSPars.IsEmpty())
	{
		POSITION pos=FSPars.GetHeadPosition();
		ret=pos;
		while(pos)
		{
			FSPAR akt;
			akt=FSPars.GetNext(pos);
			if(akt.pid==pid)
				break;
			ret=pos;
		}
	}
	return ret;
}*/


//** ------------------------------------------------------------------------ **
// Routine 19
//	void addFSP2List(void *dta,int attr,char *filename)
//	Fgt eine FSPar-Struktur an die Liste an
//	Parameter:	dta:	DTA-Adresse
//				attr:	und
//				filename:	Parameter von Fsfirst
//	Ergebnis:	keines		
//	3.1.04 von Dimitri Junker	DYJ 1.10a
//** ------------------------------------------------------------------------ **
static void addFSP2List(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
//DYJ 1.11a Start
	POSITION pos=findFSPbyDTA(r->a0);
	if(pos)
	{
		FSPAR akt;
		akt=FSPars.GetAt(pos);
		akt.attr=(short int)r->d0;
		akt.filename = (char *) (*m_info.intel_ptr)(r->a1);
		logPrintf("addFSP2List overwrite: DTA:%d attr:%d fname:%s\n",akt.dta,akt.attr,akt.filename);
		FSPars.SetAt(pos,akt);
	}
	else
	{
		FSPAR newFs;
		newFs.dta=r->a0;
		newFs.attr=(short int)r->d0;
		newFs.filename = (char *) (*m_info.intel_ptr)(r->a1);
		logPrintf("addFSP2List new: DTA:%d attr:%d fname:%s\n",newFs.dta,newFs.attr,newFs.filename);
		FSPars.AddTail(newFs);
	}
/*DYJ  Ende; alt:	
	POSITION pos=findFSPbyID((short int)r->d0);
	if(pos)
	{
		FSPAR akt;
		akt=FSPars.GetAt(pos);
		akt.attr=(short int)r->d1;
		akt.filename = (char *) (*m_info.intel_ptr)(r->a0);
		logPrintf("addFSP2List overwrite: DTA:%d attr:%d fname:%s\n",akt.dta,akt.attr,akt.filename);
		FSPars.SetAt(pos,akt);
	}
	else
	{
		FSPAR newFs;
		newFs.dta=r->d0;
		newFs.attr=(short int)r->d1;
		newFs.filename = (char *) (*m_info.intel_ptr)(r->a0);
		logPrintf("addFSP2List new: DTA:%d attr:%d fname:%s\n",newFs.dta,newFs.attr,newFs.filename);
		FSPars.AddTail(newFs);
	}
*/
}
//** ------------------------------------------------------------------------ **
// Routine 20
//	int getFSP(char *filename,int pid)
//	gibt den Inhalt eines FSPAR zurck:
//	Parameter:	filename:	fr die Rckgabe des Pfades, darf auch NULL sein
//				pid:	PID nach der gesucht werden soll
//	Ergebnis:	Attribut den rest ber die obigen Pointer
//	3.1.04 von Dimitri Junker	DYJ 1.10a
//** ------------------------------------------------------------------------ **
static void getFSP(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	FSPAR akt;
//DYJ 1.11a Start
	POSITION pos=findFSPbyDTA(r->a1);
	short int attr=0;
	char *filename= (char*)(*m_info.intel_ptr)(r->a0);
	if(pos)
	{
		akt=FSPars.GetAt(pos);
		if(filename)
			strcpy(filename,akt.filename);
		attr=akt.attr;
	}
	else
		*filename='\0';
	if(filename)
		logPrintf("getFSP  ID:%d ->%d, %s\n",r->a1,attr,filename);
	else
		logPrintf("getFSP  ID:%d ->%d\n",r->a1,attr);
/*DYJ  Ende; alt:	
	POSITION pos=findFSPbyID((short int)r->d0);
	short int attr=0;
	char *filename= (char*)(*m_info.intel_ptr)(r->a0);
	if(pos)
	{
		akt=FSPars.GetAt(pos);
		if(filename)
			strcpy(filename,akt.filename);
		attr=akt.attr;
	}
	else
		*filename='\0';
	if(filename)
		logPrintf("getFSP  ID:%d ->%d, %s\n",r->d0,attr,filename);
	else
		logPrintf("getFSP  ID:%d ->%d\n",r->d0,attr);
*/
	r->d0=attr;
}
//** ------------------------------------------------------------------------ **
// Routine 21
//  static void winPexec(MPS_motregs *r)
//	Setzt ein Pexec auf _spawn um
//	Parameter:
//	Ergebnis:	keines
//	25.10.03 von Dimitri Junker	DYJ 1.13a
//** ------------------------------------------------------------------------ ***/
static void winPexec(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	char *filenameMPS= (char*)(*m_info.intel_ptr)(r->a0);
	char *cmd= (char*)(*m_info.intel_ptr)(r->a1);
	int argvMode=r->d0;
	int err=0;
	CString winPath;
	logPrintf("winPexec: %s,ARGVMode=%d\n",filenameMPS,argvMode);

	err=cv_MPC2WIN(winPath,filenameMPS);
	if(!err)
	{
		char *arg=cmd,*nxt;
		const char **argv;
		int maxArgNr=0;
		CArray<CString,CString> args;
		args.Add(winPath);
		while(arg && *arg)
		{
			CString aktArg;
			if(!argvMode)
			{
				nxt=strchr(arg,' ');
				if(nxt)
					*(nxt++)='\0';

			}
			else
				nxt=strchr(arg,'\0')+1;
			err=cv_MPC2WIN(aktArg,arg);
			if(!err)
				maxArgNr=args.Add(aktArg);
			else
				maxArgNr=args.Add(arg);
			logPrintf("  Param %d: %s\n",maxArgNr,args[maxArgNr]);
			arg=nxt;
		}
		argv=(const char**)malloc(sizeof(char*)*(maxArgNr+2));
		for(int i=0;i<=maxArgNr;i++)
		{
			if(strchr(args[i],' '))
				args[i]="\""+args[i]+"\"";
			argv[i]=args[i];
		}
		argv[++maxArgNr]=NULL;
		err=_spawnv(_P_NOWAIT,winPath,argv);
	}
	logPrintf("winPexec: err=:%d\n",err);
	r->d0= err;
}
//** ------------------------------------------------------------------------ **
// Routine 22
//  static void setScrp(char *filename)
//	kopiert ein scrp.* in die Windows-Zwischenablage
//	Parameter:	Pfad des Atari-scrap-Files
//	Ergebnis:	keines
//	25.10.03 von Dimitri Junker	DYJ 1.13a
//** ------------------------------------------------------------------------ ***/
static void setScrp(MPS_motregs *r)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	if(r->a0)
	{
		char *filenameMPS= (char*)(*m_info.intel_ptr)(r->a0);
		int err;
		CString winPath;
		logPrintf("setScrp: %s\n",filenameMPS);

		err=cv_MPC2WIN(winPath,filenameMPS);
		if(!err)
		{
			CString txt;
			CStdioFile scrpFile;
			if(scrpFile.Open(winPath,CFile::typeBinary))
			{
				int atari_tab[256] ={
					0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, /* 0 - 7 */
					0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F, /* 8 - F */
					0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17, /* 10 - 17 */
					0x18, 0x19, 0x1A, 0x1B, 0x1C, 0x1D, 0x1E, 0x1F, /* 18 - 1F */
					0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27, /* 20 - 27 */
					0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D, 0x2E, 0x2F, /* 28 - 2F */
					0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, /* 30 - 37 */
					0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x3D, 0x3E, 0x3F, /* 38 - 3F */
					0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, /* 40 - 47 */
					0x48, 0x49, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F, /* 48 - 4F */
					0x50, 0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, /* 50 - 57 */
					0x58, 0x59, 0x5A, 0x5B, 0x5C, 0x5D, 0x5E, 0x5F, /* 58 - 5F */
					0x60, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67, /* 60 - 67 */
					0x68, 0x69, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x6F, /* 68 - 6F */
					0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76, 0x77, /* 70 - 77 */
					0x78, 0x79, 0x7A, 0x7B, 0x7C, 0x7D, 0x7E, 0x7F, /* 78 - 7F */
					0xC7, 0xFC, 0xE9, 0xE2, 0xE4, 0xE0, 0xE5, 0xE7, /* 80 - 87 */
					0xEA, 0xEB, 0xE8, 0xEF, 0xEE, 0xEC, 0xC4, 0xC5, /* 88 - 8F */
					0xC9, 0xE6, 0xC6, 0xF4, 0xF6, 0xF2, 0xFB, 0xF9, /* 90 - 97 */
					0xFF, 0xD6, 0xDC, 0xA2, 0xA3, 0xA5, 0xDF, 0x83, /* 98 - 9F */
					0xE1, 0xED, 0xF3, 0xFA, 0xF1, 0xD1, 0xAA, 0xBA, /* A0 - A7 */
					0xBF, 0x9A, 0xAC, 0xBD, 0xBC, 0xA1, 0xAB, 0xBB, /* A8 - AF */
					0xE3, 0xF5, 0xD8, 0xF8, 0x9C, 0x8C, 0xC0, 0xC3, /* B0 - B7 */
					0xD5, 0xA8, 0xB4, 0x86, 0xB6, 0xA9, 0xAE, 0x99, /* B8 - BF */
					0x9F, 0x8E, 0x88, 0x91, 0x92, 0x9E, 0x89, 0x8B, /* C0 - C7 */
					0x9B, 0x81, 0x8D, 0x8F, 0x90, 0xC1, 0xC2, 0xCB, /* C8 - CF */
					0x98, 0xCD, 0xCE, 0xD3, 0xD4, 0xDA, 0xA0, 0xAD, /* D0 - D7 */
					0xC8, 0xCA, 0xCC, 0xCF, 0xD0, 0xA7, 0x96, 0x97, /* D8 - DF */
					0xD7, 0xD9, 0xB8, 0xB9, 0xBE, 0xD2, 0xB5, 0xDB, /* E0 - E7 */
					0x82, 0xDD, 0xDE, 0xF0, 0x80, 0xFD, 0xFE, 0x8A, /* E8 - EF */
					0x93, 0xB1, 0x94, 0x84, 0x87, 0x85, 0xF7, 0xA4, /* F0 - F7 */
					0xB0, 0x95, 0xB7, 0xA6, 0x9D, 0xB2, 0xB3, 0xAF}; /* F8 - FF */
				int len=scrpFile.GetLength();
				unsigned char *buffer=new unsigned char[len],*pGlobalMemory;
				scrpFile.ReadHuge(buffer,len);
				HGLOBAL hGlobalMemory=GlobalAlloc(GHND,len+1);
				scrpFile.Close();
				pGlobalMemory=(unsigned char *)GlobalLock(hGlobalMemory);
				for(int i=0;i<len;i++)
					*pGlobalMemory++=(unsigned char)atari_tab[buffer[i]];
				GlobalUnlock(hGlobalMemory);
				OpenClipboard(NULL);
				EmptyClipboard();
				SetClipboardData(CF_TEXT,hGlobalMemory);
				CloseClipboard();


			}
				
		}
	}
	else
	{
		logPrintf("setScrp: NULL\n");
		OpenClipboard(NULL);
		EmptyClipboard();
		CloseClipboard();
	}
}
